/**************************************************************************************************
  Common.h
  Defines a pool of buffers for printing messages.


  Copyright (C) 2007  Val Gretchev

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.

**************************************************************************************************/
#ifndef COMMON_H
#define COMMON_H


// Defines
#define TRUE 1
#define FALSE 0

// See http://www.asciitable.com/
#define NUL 0                     // Null
#define SOH 1                     // Start Of Heading
#define STX 2                     // Start Of Text
#define ETX 3                     // End Of Text
#define EOT 4                     // End Of Transmission
#define ENQ 5                     // Enquiry
#define ACK 6                     // Acknowledge
#define BEL 7                     // Bell
#define BS  8                     // Backspace
#define TAB 9                     // Horizontal tab
#define LF  10                    // Line feed, new line
#define VT  11                    // Vertical tab
#define FF  12                    // Form feed, new page
#define CR  13                    // Carriage return, return
#define SO  14                    // Shift out
#define SI  15                    // Shift in
#define DLE 16                    // Data link escape
#define DC1 17                    // Device Control 1
#define DC2 18                    // Device Control 2
#define DC3 19                    // Device Control 3
#define DC4 20                    // Device Control 4
#define NAK 21                    // Negative Acknowledge
#define SYN 22                    // Synchronous idle
#define ETB 23                    // End of transmission block
#define CAN 24                    // Cancel
#define EM  25                    // End of medium
#define SUB 26                    // Substitute
#define ESC 27                    // Escape
#define FS  28                    // File separator
#define GS  29                    // Group separator
#define RS  30                    // Record separator
#define US  31                    // Unit separator



// Diagnostic output for USART2 ********************************************************************
#define USART2_DEBUG 0       // Set to 0 to prevent USART2 diagnostic messages on USB

#if USART2_DEBUG == 1
#define USART2_DEBUGOUT(c) USB_PutQueue(c)
#else
#define USART2_DEBUGOUT(c) {}
#endif

// Diagnostic output for UART3 ********************************************************************
#define USART3_DEBUG 0    // Set to 0 to prevent USART3 diagnostic messages on USB

#if USART3_DEBUG == 1
#define USART3_DEBUGOUT(c) USB_PutQueue(c)
#else
#define USART3_DEBUGOUT(c) {}
#endif

// Diagnostic output for USB **********************************************************************
#define USB_DEBUG 0      // Set to 0 to prevent USB diagnostic messages on USB

#if USB_DEBUG == 1
#define USB_DEBUGOUT(c) USB_PutQueue(c)
#else
#define USB_DEBUGOUT(c) {}
#endif

// Diagnostic output for WiFi_ESP *****************************************************************
#define WIFI_DEBUG 1       // Set to 0 to prevent WiFi ESP diagnostic messages on USB

#if WIFI_DEBUG == 1
#define WIFI_DEBUGOUT(c) USB_PutQueue(c)
#else
#define WIFI_DEBUGOUT(c) {}
#endif








// Structures
typedef void (*tPointerFcn)(void);  // Pointer to a function


#endif

/**************************************************************************************************
  End of File
**************************************************************************************************/