/**************************************************************************************************
  Init_task.c
  This file contains the init task which initializes structures and other tasks.
**************************************************************************************************/

// Include Files
#include <stddef.h>
#include "FreeRTOSConfig.h"
#include "FreeRTOS.h"
#include "task.h"
#include "queue.h"
#include "semphr.h"
#include "timers.h"
#include "projdefs.h"
#include "portmacro.h"

#include "Init_task.h"


/**************************************************************************************************
// Initializes structures and other tasks. Should be the only task initialized in main.
**************************************************************************************************/
void initTask(void *pvParameters)
{

     //Initialize tasks
     //
     // USB receive task
     xTaskCreate(
          (TaskFunction_t)usbRcvTask,
          "USB Receive Task",
          configMINIMAL_STACK_SIZE,
          NULL,
          10,
          NULL
     );
     //

     //
     // USB transmit task
     xTaskCreate(
          (TaskFunction_t)usbXmtTask,
          "USB Transmit Task",
          configMINIMAL_STACK_SIZE,
          NULL,
          10,
          NULL
     );
     //

     //
     // USART2 receive task
     xTaskCreate(
          (TaskFunction_t)USART2_RcvTask,
          "U2 RcvTask",
          configMINIMAL_STACK_SIZE,
          NULL,
          10,
          NULL
     );
     //

     //
     // USART2 transmit task
     xTaskCreate(
          (TaskFunction_t)USART2_XmtTask,
          "U2 XmtTask",
          configMINIMAL_STACK_SIZE,
          NULL,
          10,
          NULL
     );
     //

     //
     // USART3 receive task
     xTaskCreate(
          (TaskFunction_t)USART3_RcvTask,
          "U3 RcvTask",
          configMINIMAL_STACK_SIZE,
          NULL,
          10,
          NULL
     );
     //

     //
     // USART3 transmit task
     xTaskCreate(
          (TaskFunction_t)USART3_XmtTask,
          "U3 XmtTask",
          configMINIMAL_STACK_SIZE,
          NULL,
          10,
          NULL
     );
     //

     /*
     // Timer task
     xTaskCreate(
          (TaskFunction_t)timerTask,
          "Timer Task",
          configMINIMAL_STACK_SIZE,
          NULL,
          10,
          NULL
     );
     */

     /*
     // SDcard task
     xTaskCreate(
          (TaskFunction_t)SDcardTask,
          "SDcard Task",
          configMINIMAL_STACK_SIZE,
          NULL,
          10,
          NULL
     );
     */

     //
     // TFT task
     xTaskCreate(
          (TaskFunction_t)tftTask,
          "TFT Draw Task",
          configMINIMAL_STACK_SIZE,
          NULL,
          10,
          NULL
     );
     //

     //
     // WiFiESP task
     xTaskCreate(
          (TaskFunction_t)WiFiESP_Task,
          "WiFiESP Task",
          configMINIMAL_STACK_SIZE,
          NULL,
          10,
          NULL
     );
     //


     // This task has served its purpose. Delete it.
     vTaskDelete(NULL);  // NULL means this task
}

/**************************************************************************************************
  End of File
**************************************************************************************************/