#line 1 "C:/Mikroelektronika/EasyMx PRO v7 for STM32 ARM/Projects/Breskva/3-My Code/RTC.c"
#line 1 "c:/mikroelektronika/easymx pro v7 for stm32 arm/projects/breskva/3-my code/rtc.h"
#line 28 "c:/mikroelektronika/easymx pro v7 for stm32 arm/projects/breskva/3-my code/rtc.h"
typedef struct Time {
 short ampm;
 short seconds;
 short minutes;
 short hours;
 short day;
 short month;
 int year;
} TTime;




void RTC_Initialize(void);
void RTC_Write(TTime *RTCC_Time);
void RTC_Read(TTime *RTCC_Time);

void RTC_WriteSRAM(unsigned short Reg, unsigned long Value);
unsigned long RTC_ReadSRAM(unsigned short Reg);

void RTC_WriteCCR(char Cal);
void RTC_ReadCCR(void);
void SetTime(void);
void GetTime(void);
char* GetTimeStampStr(void);
#line 1 "c:/mikroelektronika/easymx pro v7 for stm32 arm/projects/breskva/3-my code/buffers.h"
#line 32 "c:/mikroelektronika/easymx pro v7 for stm32 arm/projects/breskva/3-my code/buffers.h"
char* GetBuffer(void);
#line 1 "c:/mikroelektronika/easymx pro v7 for stm32 arm/projects/breskva/3-my code/usb_driver3.h"
#line 28 "c:/mikroelektronika/easymx pro v7 for stm32 arm/projects/breskva/3-my code/usb_driver3.h"
void USB_Initialize(void);
void USB_CheckIn(void);

void USB_PutQueue(char *msg);
void USB_CheckOut(void);
#line 31 "C:/Mikroelektronika/EasyMx PRO v7 for STM32 ARM/Projects/Breskva/3-My Code/RTC.c"
TTime MyTime;

unsigned long RTC_Time;
unsigned long RTC_Date;
#line 43 "C:/Mikroelektronika/EasyMx PRO v7 for STM32 ARM/Projects/Breskva/3-My Code/RTC.c"
void RTC_Initialize(void) {

 RCC_APB1ENR.PWREN = 1;

 if (RCC_BDCR.RTCEN == 0) {
 PWR_CR.DBP = 1;
 RTC_WPR = 0xCA;
 RTC_WPR = 0x53;

 RCC_BDCR = 0x00010000;
 RCC_BDCR = 0x00008101;
 }

 while(RTC_ISR.RSF != 1) {}
 while(RCC_BDCR.LSERDY != 1) {};

 RTC_WPR = 0xFF;

 USB_PutQueue("RTC initialized\r\n");
}
#line 67 "C:/Mikroelektronika/EasyMx PRO v7 for STM32 ARM/Projects/Breskva/3-My Code/RTC.c"
void RTC_Write(TTime *RTCC_Time) {
 unsigned long temp;

 PWR_CR.DBP = 1;
 RTC_WPR = 0xCA;
 RTC_WPR = 0x53;

 RTC_ISR = 0x00000080;

 while(RTC_ISR.INITF != 1) {};

 RTC_PRERbits.PREDIV_S = 0xFF;
 RTC_PRERbits.PREDIV_A = 0x7F;


 temp = (unsigned long)Dec2Bcd(RTCC_Time->hours) << 16;
 temp += (unsigned long)Dec2Bcd(RTCC_Time->minutes) << 8;
 temp += (unsigned long)Dec2Bcd(RTCC_Time->seconds);

 RTC_TR = temp;


 temp = (unsigned long)Dec2Bcd16(RTCC_Time->year) << 16;
 temp += (unsigned long)Dec2Bcd(RTCC_Time->month) << 8;
 temp += (unsigned long)Dec2Bcd(RTCC_Time->day);
 RTC_DR = temp;

 RTC_CRbits.FMT = 0;
 RTC_CRbits.WCKSEL = 0;

 RTC_ISR = 0x00000000;

 RTC_WPR = 0xFF;
}
#line 105 "C:/Mikroelektronika/EasyMx PRO v7 for STM32 ARM/Projects/Breskva/3-My Code/RTC.c"
void RTC_Read(TTime *RTCC_Time) {

 RTC_Time = RTC_TR;
 RTC_Date = RTC_DR;


 RTCC_Time->hours = Bcd2Dec((short)((RTC_Time & 0x3F0000) >> 16));
 RTCC_Time->minutes = Bcd2Dec((short)((RTC_Time & 0x007F00) >> 8));
 RTCC_Time->seconds = Bcd2Dec((short)(RTC_Time & 0x00007F));


 RTCC_Time->year = Bcd2Dec16((unsigned)((RTC_Date & 0xFFFF0000) >> 16));
 RTCC_Time->month = Bcd2Dec((short)((RTC_Date & 0x001F00) >> 8));
 RTCC_Time->day = Bcd2Dec((short)(RTC_Date & 0x00003F));
}
#line 124 "C:/Mikroelektronika/EasyMx PRO v7 for STM32 ARM/Projects/Breskva/3-My Code/RTC.c"
void RTC_WriteSRAM(unsigned short Reg, unsigned long Value) {

 switch (Reg) {
 case 0: RTC_BKP0R = Value; break;
 case 1: RTC_BKP1R = Value; break;
 case 2: RTC_BKP2R = Value; break;
 case 3: RTC_BKP3R = Value; break;
 case 4: RTC_BKP4R = Value; break;
 case 5: RTC_BKP5R = Value; break;
 case 6: RTC_BKP6R = Value; break;
 case 7: RTC_BKP7R = Value; break;
 case 8: RTC_BKP8R = Value; break;
 case 9: RTC_BKP9R = Value; break;
 case 10: RTC_BKP10R = Value; break;
 case 11: RTC_BKP11R = Value; break;
 case 12: RTC_BKP12R = Value; break;
 case 13: RTC_BKP13R = Value; break;
 case 14: RTC_BKP14R = Value; break;
 case 15: RTC_BKP15R = Value; break;
 case 16: RTC_BKP16R = Value; break;
 case 17: RTC_BKP17R = Value; break;
 case 18: RTC_BKP18R = Value; break;
 case 19: RTC_BKP19R = Value; break;
 default: USB_PutQueue("Invalid reg address\r\n"); break;
 }
}
#line 154 "C:/Mikroelektronika/EasyMx PRO v7 for STM32 ARM/Projects/Breskva/3-My Code/RTC.c"
unsigned long RTC_ReadSRAM(unsigned short Reg) {
 unsigned long Temp;

 switch (Reg) {
 case 0: Temp = RTC_BKP0R; break;
 case 1: Temp = RTC_BKP1R; break;
 case 2: Temp = RTC_BKP2R; break;
 case 3: Temp = RTC_BKP3R; break;
 case 4: Temp = RTC_BKP4R; break;
 case 5: Temp = RTC_BKP5R; break;
 case 6: Temp = RTC_BKP6R; break;
 case 7: Temp = RTC_BKP7R; break;
 case 8: Temp = RTC_BKP8R; break;
 case 9: Temp = RTC_BKP9R; break;
 case 10: Temp = RTC_BKP10R; break;
 case 11: Temp = RTC_BKP11R; break;
 case 12: Temp = RTC_BKP12R; break;
 case 13: Temp = RTC_BKP13R; break;
 case 14: Temp = RTC_BKP14R; break;
 case 15: Temp = RTC_BKP15R; break;
 case 16: Temp = RTC_BKP16R; break;
 case 17: Temp = RTC_BKP17R; break;
 case 18: Temp = RTC_BKP18R; break;
 case 19: Temp = RTC_BKP19R; break;
 default: USB_PutQueue("Invalid reg address\r\n"); Temp = 0; break;
 }
 return Temp;
}
#line 189 "C:/Mikroelektronika/EasyMx PRO v7 for STM32 ARM/Projects/Breskva/3-My Code/RTC.c"
void RTC_WriteCCR(char Cal) {

 PWR_CR.DBP = 1;
 RTC_WPR = 0xCA;
 RTC_WPR = 0x53;
 RTC_ISR = 0x00000080;
 while(RTC_ISR.INITF != 1) {};
 RTC_CALIBR = Cal;
 RTC_ISR = 0x00000000;
 RTC_WPR = 0xFF;
}
#line 204 "C:/Mikroelektronika/EasyMx PRO v7 for STM32 ARM/Projects/Breskva/3-My Code/RTC.c"
void RTC_ReadCCR(void) {
 char *BufNum;

 BufNum = GetBuffer();
 sprintf(BufNum,"%04X\r\n",RTC_CALIBR);
 USB_PutQueue(BufNum);
}
#line 215 "C:/Mikroelektronika/EasyMx PRO v7 for STM32 ARM/Projects/Breskva/3-My Code/RTC.c"
void SetTime(void) {
 MyTime.ampm = 1;
 MyTime.seconds = 30;
 MyTime.minutes = 00;
 MyTime.hours = 14;
 MyTime.day = 16;
 MyTime.month = 12;
 MyTime.year = 16;
 RTC_Write(&MyTime);
 USB_PutQueue("Time and date set in RTC\r\n");
}
#line 230 "C:/Mikroelektronika/EasyMx PRO v7 for STM32 ARM/Projects/Breskva/3-My Code/RTC.c"
void GetTime(void) {
 char *BufNum;

 RTC_Read(&MyTime);
 BufNum = GetBuffer();
#line 244 "C:/Mikroelektronika/EasyMx PRO v7 for STM32 ARM/Projects/Breskva/3-My Code/RTC.c"
 sprintf(BufNum,"20%02d/%02d/%02d %02d:%02d:%02d\r\n",MyTime.year,MyTime.month,MyTime.day,
 MyTime.hours,MyTime.minutes,MyTime.seconds);
 USB_PutQueue(BufNum);
}
#line 252 "C:/Mikroelektronika/EasyMx PRO v7 for STM32 ARM/Projects/Breskva/3-My Code/RTC.c"
char* GetTimeStampStr(void){
 char TimeStamp[32] = {0};
 char *BufNum;





 RTC_Read(&MyTime);
 TimeStamp[0] = 0x08;

 TimeStamp[2] = MyTime.year;
 TimeStamp[3] = MyTime.month;
 TimeStamp[4] = MyTime.day;
 TimeStamp[5] = MyTime.hours;
 TimeStamp[6] = MyTime.minutes;
 TimeStamp[7] = MyTime.seconds;



 BufNum = GetBuffer();


 sprintf(BufNum,"%02d/%02d/%02d %02d:%02d:%02d",TimeStamp[2],TimeStamp[3],TimeStamp[4],
 TimeStamp[5],TimeStamp[6], TimeStamp[7]);

 USB_PutQueue(BufNum);
 return TimeStamp;
}
